﻿using System;
using System.Text;

namespace FlutterCodeGenerator.ModelTypes
{
    internal class EnumNullableModelType : ComplexModelType
    {
        public EnumNullableModelType(Type type, string name) : base(type, name)
        {
        }

        public override string GetFlutterTypeName(bool isDefault = true, bool isGenericName = false, bool isSingle = false)
        {
            if (Index > 1)
            {
                return $"{ParameterType.Name}{Index}";
            }
            else
            {
                return $"{ParameterType.Name}";
            }
        }

        public override string GetDartString()
        {
            var dartString = new StringBuilder();
            dartString.AppendLine($"enum {GetFlutterTypeName()} {{");
            foreach (var enumvalue in Enum.GetNames(ParameterType))
            {
                dartString.AppendLine($"\t{enumvalue},");
            }
            dartString.AppendLine("}");
            return dartString.ToString();
        }
    }
}