﻿using FlutterCodeGenerator.Helper;
using System;

namespace FlutterCodeGenerator.ModelTypes
{
    internal class ListModelType : SimpleModelType
    {
        public ModelType GenericArgumentModelType;

        public ListModelType(Type type, string name) : base(type, name)
        {
            var modelType = ModelTypeGenerator.Create(type.GetGenericArguments()[0], "");
            GenericArgumentModelType = modelType;
        }

        public override string GetFlutterTypeName(bool isDefault = true, bool isGenericName = false, bool isSingle = false)
        {
            if (isDefault)
            {
                return "List<" + GenericArgumentModelType.GetFlutterTypeName() + ">";
            }

            if (isGenericName)
            {
                return "List<T>";
            }
            if (isSingle)
            {
                return "List";
            }

            return "List<" + GenericArgumentModelType.GetFlutterTypeName() + ">";
        }
    }
}